import javax.naming.*;
import javax.jms.*;

public class BBSender {

    private Connection connection;
    private Session session;
    private MessageProducer producer;

    public static void main(String[] args) {
        BBSender sender = null;
        try {
            sender = new BBSender();
            System.out.println ("Sending message Hello World");
            sender.sendMessage("Hello World");
        } 
        catch(Exception ex) {
            System.err.println("Exception in BBSSender: " + ex);
        }
        finally {
            try {sender.close();} catch(Exception ex){}
        }
    }

    public BBSender() throws JMSException, NamingException {
        Context context = new InitialContext();
        ConnectionFactory connectionFactory = (ConnectionFactory)context.lookup("jms/TopicConnectionFactory");
        connection = connectionFactory.createConnection();
        session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
        Destination destination = (Destination)context.lookup("jms/bulletinBoard");
        producer = session.createProducer(destination);
    }

    public void sendMessage(String msg) throws JMSException {
        TextMessage message = session.createTextMessage();
        message.setText(msg);
        producer.send(message);
    }

    public void close() throws JMSException {
        producer.close();
        session.close();
        connection.close();
    }
}
